/*
 * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */


#ifndef _SYS_LIBV12N_H
#define	_SYS_LIBV12N_H

#pragma ident	"@(#)libv12n.h	1.1	10/03/24 SMI"

#include <sys/types.h>
#include <uuid/uuid.h>

#ifdef	__cplusplus
extern "C" {
#endif

/* Max length of an v12n name/uuid/serialno */
#define	V12N_NAME_MAX		1024

/* Virtualization capabilities - bit mask */
#define	V12N_CAP_SUPPORTED	0x1	/* Virtualization supported */
#define	V12N_CAP_ENABLED	0x2	/* Virtualization enabled */
#define	V12N_CAP_IMPL_LDOMS	0x4	/* LDoms Implementation */

/* LDoms Domain role types - bit mask */
#define	V12N_ROLE_CONTROL	0x1	/* LDoms Ctrl domain (zero = Guest) */
#define	V12N_ROLE_IO		0x2	/* I/O domain */
#define	V12N_ROLE_SERVICE	0x4	/* Service domain */
#define	V12N_ROLE_ROOT		0x8	/* Root domain */

int v12n_capabilities(void);
int v12n_domain_roles(void);
int v12n_domain_uuid(uuid_t);
size_t v12n_domain_name(char *, size_t);
size_t v12n_ctrl_domain(char *, size_t);
size_t v12n_chassis_serialno(char *, size_t);

#ifdef	__cplusplus
}
#endif

#endif /* _SYS_LIBV12N_H */
