/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef	_SYS_INTR_H
#define	_SYS_INTR_H

#pragma ident	"@(#)intr.h	1.13	07/09/06 SMI"

#ifdef	__cplusplus
extern "C" {
#endif

/*
 * OBSOLETE.
 *
 * Retained to preserve the size of machcpu structures.
 */
#define	INTR_PENDING_MAX	64

/*
 * Allocate threads and stacks for interrupt handling.
 */
#define	NINTR_THREADS	(LOCK_LEVEL)	/* number of interrupt threads */

/*
 * Each cpu allocates two arrays, intr_head[] and intr_tail[], with the
 * size of PIL_LEVELS each. The entry 0 of these arrays are reserved.
 *
 * The entries 1-15 of the arrays are the head and the tail of interrupt
 * level 1-15 request queues.
 */
#define	PIL_LEVELS	16	/* 0    : reserved */
				/* 1-15 : for the pil level 1-15 */

#define	PIL_1	1
#define	PIL_2	2
#define	PIL_3	3
#define	PIL_4	4
#define	PIL_5	5
#define	PIL_6	6
#define	PIL_7	7
#define	PIL_8	8
#define	PIL_9	9
#define	PIL_10	10
#define	PIL_11	11
#define	PIL_12	12
#define	PIL_13	13
#define	PIL_14	14
#define	PIL_15	15

#ifndef _ASM
extern uint64_t poke_cpu_inum;
extern void intr_init(struct cpu *);

/*
 * interrupt request entry
 *
 *	- OBSOLETE.  This structure has been replaced by struct intr_vec
 *	  but is only retained to preserve the size of machcpu structures.
 */
struct intr_req {
	uint_t		intr_number;
	struct intr_req	*intr_next;
};

#endif	/* !_ASM */

#ifdef	__cplusplus
}
#endif

#endif	/* _SYS_INTR_H */
