/*
 * Copyright (c) 1985,1997-1998 by Sun Microsystems, Inc.
 * All rights reserved.
 */

/*
 * This file describes a virtual user input device (vuid) state
 * maintainence package (see ../sundev/vuid_event.h for a description
 * of what vuid is).  This header file defines the interface that a
 * client of this package sees.	 This package is used to maintain the
 * state of all the events generated by an arbitrary number of physical
 * devices which are all producing Firm_events.
 */

#ifndef _SYS_VUID_STATE_H
#define	_SYS_VUID_STATE_H

#pragma ident	"@(#)vuid_state.h	1.6	98/01/06 SMI"	/* SunOS 1.5 */

#ifdef	__cplusplus
extern "C" {
#endif

typedef caddr_t Vuid_state;
#define	VUID_STATE_NULL ((Vuid_state)0)

void	vuid_set_value();	/* (Vuid_state *state, Firm_event *event) */
				/* Don't call in critical section or */
				/* at interrupt level */
int	vuid_get_value();	/* (Vuid_state state, ushort_t id) */
void	vuid_destroy_state();	/* (Vuid_state state) Don't call in critical */
				/* section or at interrupt level */
Vuid_state vuid_copy_state();	/* (Vuid_state state) Don't call in critical */
				/* section or at interrupt level */

#ifdef	__cplusplus
}
#endif

#endif	/* _SYS_VUID_STATE_H */
